﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace sms
{
    class Program
    {
        static char Kod(char ch)
        {
            int rend = (int)ch;
            int kod;
            if (rend < 100)
            {
                kod = 2;
            }
            else if (rend < 103)
            {
                kod = 3;
            }
            else if (rend < 106)
            {
                kod = 4;
            }
            else if (rend < 109)
            {
                kod = 5;

            }
            else if (rend < 112)
            {
                kod = 6;
            }
            else if (rend < 116)
            {
                kod = 7;
            }
            else if (rend < 119)
            {
                kod = 8;
            }
            else
            {
                kod = 9;
            }
            return kod.ToString()[0];
        }

        static string Kodol(string szot)
        {
            string szam = "";
            foreach (char c in szot)
            {
                szam = szam + Kod(c);
            }
            return szam;
        }


        static void Main(string[] args)
        {
            #region 1. feladat - kar->kod
            Console.Write("Adjon meg egy karaktert: ");
            Char ch = Convert.ToChar(Console.ReadLine()[0]);
            Console.WriteLine(Kod(ch));
            #endregion
            string szo;
            #region 2. feladat - szó -> számkód
            Console.Write("Adjon meg egy szót: ");
            szo = Console.ReadLine();
            foreach (char k in szo)
            {
                Console.Write(Kod(k));
            }
            Console.WriteLine();
            #endregion
            StreamReader be = new StreamReader("szavak.txt");
            string szokod;
            Dictionary<string, string> szotar = new Dictionary<string, string>();
            #region 3. feladat - adatbeolvasás
            while (!be.EndOfStream)
            {
                szo = be.ReadLine();
                szokod = Kodol(szo);
                szotar.Add(szo, szokod);
            }
            be.Close();
            #endregion
            #region 4. feladat - maxhossz
            int max = szotar.Max(e => e.Key.Length);
            string maxszo = szotar.First(e => e.Key.Length == max).Key;
            Console.WriteLine("A leghosszabb szó: {0}, hossza: {1}", maxszo, max);
            #endregion
            #region 5. feladat - rövid db
            Console.WriteLine("Rövid szavak száma: {0}", szotar.Count(e => e.Key.Length <= 5));
            #endregion
            #region 6. feladat - számkodok kiírása
            StreamWriter ki = new StreamWriter("kodok.txt");
            foreach (string kodsor in szotar.Values)
            {
                ki.WriteLine(kodsor);
            }
            ki.Close();
            #endregion
            #region 7. feladat - szokod -> szó
            Console.WriteLine("Adjon meg egy számsort: ");
            szokod = Console.ReadLine();
            foreach (KeyValuePair<string, string> k in szotar)
            {
                if (k.Value == szokod)
                {
                    Console.Write(k.Key + " ");
                }
            }
            Console.WriteLine();
            #endregion
            Dictionary<string, int> db = new Dictionary<string, int>();
            #region 8. feladat - több változat
            foreach (KeyValuePair<string, string> k in szotar)
            {
                int most = 0;
                foreach (KeyValuePair<string, int> l in db)
                {
                    if (k.Value == l.Key)
                    {
                        most = l.Value + 1;
                    }
                }
                if (most == 0)
                {
                    db.Add(k.Value, 1);
                }
                else
                {
                    db.Remove(k.Value);
                    db.Add(k.Value, most);
                }

            }
            foreach (KeyValuePair<string, int> l in db)
            {
                if (l.Value > 1)
                {
                    foreach (KeyValuePair<string, string> k in szotar)
                    {
                        if (k.Value == l.Key)
                        {
                            Console.Write(k.Key + " : " + k.Value + "; ");
                        }
                    }
                }
            }
            Console.WriteLine();
            #endregion
            #region 9. feladat - legtöbb változat
            int maxdb = db.Max(e => e.Value);
            Console.Write(db.First(e => e.Value == maxdb).Key + ": ");
            foreach (KeyValuePair<string, string> k in szotar)
            {
                if (k.Value == db.First(e => e.Value == maxdb).Key)
                {
                    Console.Write(k.Key + " ");
                }
            }
            Console.WriteLine();
            #endregion
            Console.ReadLine();
        }
    }
}
